Index: trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.icc
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.icc	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.icc	(revision 1230)
@@ -1,2 +1,28 @@
+//
+// ********************************************************************
+// * License and Disclaimer                                           *
+// *                                                                  *
+// * The  Geant4 software  is  copyright of the Copyright Holders  of *
+// * the Geant4 Collaboration.  It is provided  under  the terms  and *
+// * conditions of the Geant4 Software License,  included in the file *
+// * LICENSE and available at  http://cern.ch/geant4/license .  These *
+// * include a list of copyright holders.                             *
+// *                                                                  *
+// * Neither the authors of this software system, nor their employing *
+// * institutes,nor the agencies providing financial support for this *
+// * work  make  any representation or  warranty, express or implied, *
+// * regarding  this  software system or assume any liability for its *
+// * use.  Please see the license in the file  LICENSE  and URL above *
+// * for the full disclaimer and the limitation of liability.         *
+// *                                                                  *
+// * This  code  implementation is the result of  the  scientific and *
+// * technical work of the GEANT4 collaboration.                      *
+// * By using,  copying,  modifying or  distributing the software (or *
+// * any work based  on the software)  you  agree  to acknowledge its *
+// * use  in  resulting  scientific  publications,  and indicate your *
+// * acceptance of all terms of the Geant4 Software license.          *
+// ********************************************************************
+//
+//
 /**
  *  \file 
@@ -7,5 +33,5 @@
  *  \author Copyright 2005 __Vanderbilt University__. All rights reserved.
  *
- *	\version c2_function.cc,v 1.43 2007/11/12 20:22:54 marcus Exp
+ *	\version c2_function.cc,v 1.169 2008/05/22 12:45:19 marcus Exp
  */
 
@@ -22,5 +48,5 @@
 
 template <typename float_type> const std::string c2_function<float_type>::cvs_file_vers() const 
-{ return "c2_function.cc,v 1.43 2007/11/12 20:22:54 marcus Exp"; }
+{ return "c2_function.cc,v 1.169 2008/05/22 12:45:19 marcus Exp"; }
 
 // find a pre-bracketed root of a c2_function, which is a MUCH easier job than general root finding
@@ -33,5 +59,4 @@
 	// find f(x)=value within the brackets, using the guarantees of smoothness associated with a c2_function
 	// can use local f(x)=a*x**2 + b*x + c and solve quadratic to find root, then iterate
-	reset_evaluations();
 	
 	float_type yp, yp2; // we will make unused pointers point here, to save null checks later
@@ -47,22 +72,36 @@
 	float_type c, b;
 	
+	if(!root_info) {
+		root_info=new struct c2_root_info;
+		root_info->inited=false;
+	}
 	// this new logic is to keep track of where we were before, and lower the number of 
 	// function evaluations if we are searching inside the same bracket as before.
 	// Since this root finder has, very often, the bracket of the entire domain of the function,
 	// this makes a big difference, especially to c2_inverse_function
-	if(!rootInitialized || upper_bracket != lastRootUpperX || lower_bracket != lastRootLowerX) {
-		lastRootUpperY=value_with_derivatives(upper_bracket, final_yprime, final_yprime2);
-		increment_evaluations();
-		lastRootUpperX=upper_bracket;
-	
-		lastRootLowerY=value_with_derivatives(lower_bracket, final_yprime, final_yprime2);
-		increment_evaluations();
-		lastRootLowerX=lower_bracket;
-		rootInitialized=true;
-	}
-	
-	float_type clower=lastRootLowerY-value;
-	float_type cupper=lastRootUpperY-value;
-	if(clower*cupper >0) { 
+	if(!root_info->inited || upper_bracket != root_info->upper.x || lower_bracket != root_info->lower.x) {
+		root_info->upper.x=upper_bracket;
+		fill_fblock(root_info->upper);		
+		root_info->lower.x=lower_bracket;
+		fill_fblock(root_info->lower);
+		root_info->inited=true;
+	}
+	
+	float_type clower=root_info->lower.y-value;
+	if(!clower) {
+		*final_yprime=root_info->lower.yp;
+		*final_yprime2=root_info->lower.ypp;
+		return lower_bracket;
+	}
+	
+	float_type cupper=root_info->upper.y-value;
+	if(!cupper) {
+		*final_yprime=root_info->upper.yp;
+		*final_yprime2=root_info->upper.ypp;
+		return upper_bracket;
+	}
+	const float_type lower_sign = (clower < 0) ? -1 : 1;
+	
+	if(lower_sign*cupper >0) { 
 		// argh, no sign change in here!
 		if(error) { *error=1; return 0.0; }
@@ -104,9 +143,13 @@
 	   }
 	   c=value_with_derivatives(root, final_yprime, final_yprime2)-value; // compute initial values
+	   if(c2_isnan(c)) {
+		   bad_x_point=root;
+		   return c; // return the nan if a computation failed
+	   }
 	   b=*final_yprime; // make a local copy for readability
 	   increment_evaluations();
 
 	   // now, close in bracket on whichever side this still brackets
-	   if(c*clower < 0.0) {
+	   if(c*lower_sign < 0.0) {
 		   cupper=c;
 		   upper_bracket=root;
@@ -131,18 +174,22 @@
 
 // the recursive part of the integrator is agressively designed to minimize copying of data... lots of pointers
-template <typename float_type> float_type c2_function<float_type>::integrate_step(c2_integrate_recur &rb) const
-{
-	struct c2_integrate_fblock *fbl[3]={rb.f0, rb.f1, rb.f2}; 
-	struct c2_integrate_fblock f1; // will hold new middle values
-	float_type retvals[2]={0.0,0.0};
-	float_type lr[2];
-
-	// std::cout << "entering with " << rb.f0->x << " " << rb.f1->x << " " << rb.f2->x << std::endl;
-	
-	int depth=rb.depth; // save this from the recursion block
-	float_type abs_tol=rb.abs_tol;  // this is the value we will pass down
-	float_type *rblr=rb.lr; // save pointer to our parent's lr[2] array since it will get trampled in recursion
-	
-	if(!depth) {
+template <typename float_type> float_type c2_function<float_type>::integrate_step(c2_integrate_recur &rb) const throw(c2_exception)
+{
+	std::vector< recur_item > &rb_stack=*rb.rb_stack; // heap-based stack of data for recursion
+	rb_stack.clear();
+
+	recur_item top;
+	top.depth=0; top.done=false; top.f0index=0; top.f2index=0; top.step_sum=0;
+	
+	// push storage for our initial elements
+	rb_stack.push_back(top);
+	rb_stack.back().f1=*rb.f0;
+	rb_stack.back().done=true; // this element will never be evaluated further
+	
+	rb_stack.push_back(top);
+	rb_stack.back().f1=*rb.f1;
+	rb_stack.back().done=true; // this element will never be evaluated further
+		
+	if(!rb.inited) {
 		switch(rb.derivs) {
 			case 0:
@@ -157,57 +204,97 @@
 		
 		rb.extrap2=1.0/(rb.extrap_coef-1.0);
-	}
-	
-	for (int i=0; i<(depth==0?1:2); i++) { // handle left and right intervals, but only left one for depth=0
-		struct c2_integrate_fblock *f0=fbl[i], *f2=fbl[i+1];
-		f1.x=0.5*(f0->x + f2->x); // center of interval
-		float_type dx=f2->x - f0->x;
-		float_type dx2 = 0.5*dx;
-		float_type total;
-		
-		f1.y=value_with_derivatives(f1.x, &(f1.yp), &(f1.ypp));
-		increment_evaluations(); 
-		
+		rb.dx_tolerance=10.0*std::numeric_limits<float_type>::epsilon();
+		rb.abs_tol_min=10.0*std::numeric_limits<float_type>::min();
+		rb.inited=true;
+	}
+	
+	// now, push our first real element
+	top.f0index=0; // left element is stack[0]
+	top.f2index=1; // right element is stack[1]
+	top.abs_tol=rb.abs_tol;
+	rb_stack.push_back(top);
+		
+	while(rb_stack.size() > 2) {
+		recur_item &back=rb_stack.back();
+		if(back.done) {
+			float_type sum=back.step_sum;
+			rb_stack.pop_back();
+			rb_stack.back().step_sum+=sum; // bump our sum up to the parent
+			continue;
+		}
+		back.done=true;
+		
+		c2_fblock<float_type> &f0=rb_stack[back.f0index].f1, &f2=rb_stack[back.f2index].f1; 
+		c2_fblock<float_type> &f1=back.f1; // will hold new middle values
+		size_t f1index=rb_stack.size()-1; // our current offset
+		float_type abs_tol=back.abs_tol;
+		
+		f1.x=0.5*(f0.x + f2.x); // center of interval
+		float_type dx2=0.5*(f2.x - f0.x);
+
 		// check for underflow on step size, which prevents us from achieving specified accuracy. 
-		if(std::abs(dx) < std::abs(f1.x)*rb.rel_tol) {
+		if(std::abs(dx2) < std::abs(f1.x)*rb.dx_tolerance || std::abs(dx2) < rb.abs_tol_min) {
 			std::ostringstream outstr;
-			outstr << "Step size underflow in adaptive_partial_integrals at depth=" << depth << ", x= " << f1.x;
+			outstr << "Step size underflow in adaptive_partial_integrals at depth=" << back.depth << ", x= " << f1.x;
 			throw c2_exception(outstr.str().c_str());
 		}
 		
-		if(!depth) { // top level, total has not been initialized yet
-			switch(rb.derivs) { // create estimate of next lower order for first try
+		fill_fblock(f1);
+		if(c2_isnan(f1.y)) {
+			bad_x_point=f1.x;
+			return f1.y; // can't go any further if a nan has appeared
+		}
+		
+		bool yptrouble=f0.ypbad || f2.ypbad || f1.ypbad;
+		bool ypptrouble=f0.yppbad || f2.yppbad || f1.yppbad;
+		
+		// select the real derivative count based on whether we are at a point where derivatives exist
+		int derivs = std::min(rb.derivs, (yptrouble||ypptrouble)?(yptrouble?0:1):2);
+				
+		if(!back.depth) { // top level, total has not been initialized yet
+			switch(derivs) { // create estimate of next lower order for first try
 				case 0:
-					total=0.5*(f0->y+f2->y)*dx; break;
+					back.previous_estimate=(f0.y+f2.y)*dx2; break;
 				case 1:
-					total=(f0->y+4.0*f1.y+f2->y)*dx/6.0; break;
+					back.previous_estimate=(f0.y+4.0*f1.y+f2.y)*dx2/3.0; break;
 				case 2:
-					total=( (14*f0->y + 32*f1.y + 14*f2->y) +  dx * (f0->yp - f2->yp) ) * dx /60.; break;
+					back.previous_estimate=( (14*f0.y + 32*f1.y + 14*f2.y) +  2*dx2 * (f0.yp - f2.yp) ) * dx2 /30.; break;
 				default:
-					total=0.0; // just to suppress missing default warnings
+					back.previous_estimate=0.0; // just to suppress missing default warnings
 			}
-		} else total=rblr[i]; // otherwise, get it from previous level
+		} 
 		
 		float_type left, right;
 		
-		switch(rb.derivs) {
+		// pre-compute constants so all multiplies use a small dynamic range
+		// constants for 0 derivative integrator
+		static const float_type c0c1=5./12., c0c2=8./12., c0c3=-1./12.;
+		// constants for 1 derivative integrator
+		static const float_type c1c1=101./240., c1c2=128./240., c1c3=11./240.,
+			c1c4=13./240., c1c5=-40./240., c1c6=-3./240.;
+		// constants for 2 derivative integrator
+		static const float_type c2c1=169./40320., c2c2=1024./ 40320., c2c3=-41./40320.,
+			c2c4=2727./40320., c2c5=-5040./40320., c2c6=423./40320.,
+			c2c7=17007./40320., c2c8=24576./40320., c2c9=-1263./40320.;
+		
+		switch(derivs) {
 			case 2:
 				// use ninth-order estimates for each side, from full set of all values (!) (Thanks, Mathematica!)
-				left=	( ( (169*f0->ypp + 1024*f1.ypp -  41*f2->ypp)*dx2 + 
-							(2727*f0->yp - 5040*f1.yp +  423*f2->yp) )*dx2 + 
-						  (17007*f0->y + 24576*f1.y -  1263*f2->y) )* (dx2/40320.0);
-				right=	( ( (169*f2->ypp + 1024*f1.ypp -  41*f0->ypp)*dx2 - 
-							(2727*f2->yp - 5040*f1.yp +  423*f0->yp) )*dx2 + 
-						  (17007*f2->y + 24576*f1.y -  1263*f0->y) )* (dx2/40320.0);
-				// std::cout << f0->x << " " << f1.x << " " << f2->x <<  std::endl ;
-				// std::cout << f0->y << " " << f1.y << " " << f2->y << " " << left << " " << right << " " << total << std::endl ;
+				left=	( ( (c2c1*f0.ypp + c2c2*f1.ypp +  c2c3*f2.ypp)*dx2 + 
+							(c2c4*f0.yp + c2c5*f1.yp +  c2c6*f2.yp) )*dx2 + 
+						  (c2c7*f0.y + c2c8*f1.y +  c2c9*f2.y) )* dx2;
+				right=	( ( (c2c1*f2.ypp + c2c2*f1.ypp +  c2c3*f0.ypp)*dx2 - 
+							(c2c4*f2.yp + c2c5*f1.yp +  c2c6*f0.yp) )*dx2 + 
+						  (c2c7*f2.y + c2c8*f1.y +  c2c9*f0.y) )* dx2;
+				// std::cout << f0.x << " " << f1.x << " " << f2.x <<  std::endl ;
+				// std::cout << f0.y << " " << f1.y << " " << f2.y << " " << left << " " << right << " " << total << std::endl ;
 				break;
 			case 1:
-				left= 	( (202*f0->y + 256*f1.y + 22*f2->y) + dx*(13*f0->yp - 40*f1.yp - 3*f2->yp) ) * dx /960.;
-				right= 	( (202*f2->y + 256*f1.y + 22*f0->y) - dx*(13*f2->yp - 40*f1.yp - 3*f0->yp) ) * dx /960.;
+				left= 	( (c1c1*f0.y + c1c2*f1.y + c1c3*f2.y) + dx2*(c1c4*f0.yp + c1c5*f1.yp + c1c6*f2.yp) ) * dx2 ;
+				right= 	( (c1c1*f2.y + c1c2*f1.y + c1c3*f0.y) - dx2*(c1c4*f2.yp + c1c5*f1.yp + c1c6*f0.yp) ) * dx2 ;
 				break;
 			case 0:
-				left=	(5*f0->y + 8*f1.y - f2->y)*dx/24.;
-				right=	(5*f2->y + 8*f1.y - f0->y)*dx/24.;
+				left=	(c0c1*f0.y + c0c2*f1.y + c0c3*f2.y)*dx2;
+				right=	(c0c1*f2.y + c0c2*f1.y + c0c3*f0.y)*dx2;
 				break;
 			default:
@@ -216,32 +303,40 @@
 		}
 		
-		lr[0]= left; // left interval
-		lr[1]= right; // right interval
 		float_type lrsum=left+right;
 
-		float_type eps=std::abs(total-lrsum)*rb.eps_scale; 
-		if(rb.extrapolate) eps*=rb.eps_scale; 
-		
-		if(!rb.adapt || eps < abs_tol ||  eps < std::abs(total)*rb.rel_tol) {
-			if(depth==0 || !rb.extrapolate) retvals[i]=lrsum;
-			else {
-				retvals[i]=(rb.extrap_coef*lrsum - total)*rb.extrap2; 	
-				// std::cout << "extrapolating " << lrsum << " " << total << " " << retvals[i] << std::endl;
-				
-			}
+		bool extrapolate=back.depth && rb.extrapolate && (derivs==rb.derivs); // only extrapolate if no trouble with derivs
+		float_type eps=std::abs(back.previous_estimate-lrsum)*rb.eps_scale; 
+		if(extrapolate) eps*=rb.eps_scale; 
+		
+		if(rb.adapt && eps > abs_tol &&  eps > std::abs(lrsum)*rb.rel_tol) {
+			// tolerance not met, subdivide & recur
+			if(abs_tol > rb.abs_tol_min) abs_tol=abs_tol*0.5; // each half has half the error budget
+			top.abs_tol=abs_tol;
+			top.depth=back.depth+1;
+			
+			// save the last things we need from back before a push happens, in case 
+			// the push causes a reallocation and moves the whole stack.
+			size_t f0index=back.f0index, f2index=back.f2index;
+			
+			top.f0index=f1index; top.f2index=f2index; // insert pointers to right side data into our recursion block
+			top.previous_estimate=right;
+			rb_stack.push_back(top);
+
+			top.f0index=f0index; top.f2index=f1index; // insert pointers to left side data into our recursion block
+			top.previous_estimate=left;
+			rb_stack.push_back(top);
+
+		} else if(extrapolate) {
+			// extrapolation only happens on leaf nodes, where the tolerance was met.
+			back.step_sum+=(rb.extrap_coef*lrsum - back.previous_estimate)*rb.extrap2; 
 		} else {
-			rb.depth=depth+1; // increment depth counter
-			rb.lr=lr;  // point to our left-right values array for recursion
-			rb.abs_tol=abs_tol*0.5; // each half has half the error budget
-			rb.f0=f0; rb.f1=&f1; rb.f2=f2; // insert pointers to data into our recursion block
-			// std::cout << "recurring with " << f0->x << " " << f1.x << " " << f2->x <<  std::endl ;
-			retvals[i]=integrate_step(rb); // and recur
-		}
-	}	
-	return retvals[0]+retvals[1];
+			back.step_sum+=lrsum; 
+		}
+	}
+	return rb_stack.back().step_sum; // last element on the stack holds the sum
 }
 
 template <typename float_type> bool c2_function<float_type>::check_monotonicity(
-	const std::vector<float_type> &data, const char message[]) throw(c2_exception)
+	const std::vector<float_type> &data, const char message[]) const throw(c2_exception)
 {
 	size_t np=data.size();
@@ -269,7 +364,9 @@
 }
 
-template <typename float_type> std::vector<float_type> &c2_function<float_type>::get_sampling_grid(float_type xmin, float_type xmax) const 
-{
-	std::vector<float_type> *result=new std::vector<float_type>;
+template <typename float_type> void c2_function<float_type>::
+	get_sampling_grid(float_type xmin, float_type xmax, std::vector<float_type> &grid) const 
+{
+	std::vector<float_type> *result=&grid;
+	result->clear();
 	
 	if( !(sampling_grid) || !(sampling_grid->size()) || (xmax <= sampling_grid->front()) || (xmin >= sampling_grid->back()) ) { 
@@ -313,9 +410,8 @@
 		std::copy(sg.begin()+firstindex, sg.begin()+lastindex+1, result->begin()+initsize);
 		result->back()=xmax;
-		
+
 		//  this is the unrefined sampling grid... now check for very close points on front & back and fix if needed.
 		preen_sampling_grid(result);
 	}
-	return *result;
 }
 
@@ -351,6 +447,6 @@
 }
 
-template <typename float_type> std::vector<float_type> &c2_function<float_type>::
-	refine_sampling_grid(const std::vector<float_type> &grid, size_t refinement) const
+template <typename float_type> void c2_function<float_type>::
+	refine_sampling_grid(std::vector<float_type> &grid, size_t refinement) const
 {
 	size_t np=grid.size();
@@ -358,61 +454,68 @@
 	float_type dxscale=1.0/refinement;
 	
-	std::vector<float_type> *result=new std::vector<float_type>(count);
+	std::vector<float_type> result(count);
 	
 	for(size_t i=0; i<(np-1); i++) {
 		float_type x=grid[i];
 		float_type dx=(grid[i+1]-x)*dxscale;
-		for(size_t j=0; j<refinement; j++, x+=dx) (*result)[i*refinement+j]=x;
-	}
-	(*result)[count-1]=grid.back();
-	return *result;
+		for(size_t j=0; j<refinement; j++, x+=dx) result[i*refinement+j]=x;
+	}
+	result.back()=grid.back();
+	grid=result; // copy the expanded grid back to the input
 }
 
 template <typename float_type> float_type c2_function<float_type>::integral(float_type xmin, float_type xmax, std::vector<float_type> *partials,
-	 float_type abs_tol, float_type rel_tol, int derivs, bool adapt, bool extrapolate) const
-{
-	std::vector<float_type> &grid=get_sampling_grid(xmin, xmax);
-	float_type intg=partial_integrals(grid, partials, abs_tol, rel_tol, adapt, extrapolate);
-	delete &grid;
+	 float_type abs_tol, float_type rel_tol, int derivs, bool adapt, bool extrapolate) const throw(c2_exception)
+{
+	if(xmin==xmax) {
+		if(partials) partials->clear();
+		return 0.0;
+	}
+	std::vector<float_type> grid;
+	get_sampling_grid(xmin, xmax, grid);
+	float_type intg=partial_integrals(grid, partials, abs_tol, rel_tol, derivs, adapt, extrapolate);
 	return intg;
 }
 
 template <typename float_type> c2_function<float_type> &c2_function<float_type>::normalized_function(float_type xmin, float_type xmax, float_type norm) 
+	const throw(c2_exception)
 {
 	float_type intg=integral(xmin, xmax);
-	return *new c2_scaled_function<float_type>(*this, norm/intg);
-}
-
-template <typename float_type> c2_function<float_type> &c2_function<float_type>::square_normalized_function(float_type xmin, float_type xmax, float_type norm) 
-{
-	c2_quadratic<float_type> q(0., 0., 0., 1.);
-	c2_composed_function<float_type> mesquared(q,*this);
-	
-	std::vector<float_type> grid(get_sampling_grid(xmin, xmax));		
-	float_type intg=mesquared.partial_integrals(grid);
-	
-	return *new c2_scaled_function<float_type>(*this, std::sqrt(norm/intg));
+	return *new c2_scaled_function_p<float_type>(*this, norm/intg);
+}
+
+template <typename float_type> c2_function<float_type> &c2_function<float_type>::square_normalized_function(float_type xmin, float_type xmax, float_type norm)
+	const throw(c2_exception)
+{
+	c2_ptr<float_type> mesquared((*new c2_quadratic_p<float_type>(0., 0., 0., 1.))(*this));
+	
+	std::vector<float_type> grid;
+	get_sampling_grid(xmin, xmax, grid);		
+	float_type intg=mesquared->partial_integrals(grid);
+	
+	return *new c2_scaled_function_p<float_type>(*this, std::sqrt(norm/intg));
 }
 
 template <typename float_type> c2_function<float_type> &c2_function<float_type>::square_normalized_function(
 		float_type xmin, float_type xmax, const c2_function<float_type> &weight, float_type norm) 
-{
-	c2_quadratic<float_type> q(0., 0., 0., 1.);
-	c2_composed_function<float_type> mesquared(q,*this);
-	c2_product<float_type> weighted(mesquared, weight); 
-
-	std::vector<float_type> grid(get_sampling_grid(xmin, xmax));	
-	float_type intg=weighted.partial_integrals(grid);
-
-	return *new c2_scaled_function<float_type>(*this, std::sqrt(norm/intg));
+	const throw(c2_exception)
+{
+	c2_ptr<float_type> weighted((*new c2_quadratic_p<float_type>(0., 0., 0., 1.))(*this) * weight);
+
+	std::vector<float_type> grid;
+	get_sampling_grid(xmin, xmax, grid);	
+	float_type intg=weighted->partial_integrals(grid);
+
+	return *new c2_scaled_function_p<float_type>(*this, std::sqrt(norm/intg));
 }
 
 template <typename float_type> float_type c2_function<float_type>::partial_integrals(
 	std::vector<float_type> xgrid, std::vector<float_type> *partials,
-	float_type abs_tol, float_type rel_tol, int derivs, bool adapt, bool extrapolate) const
+	float_type abs_tol, float_type rel_tol, int derivs, bool adapt, bool extrapolate) 
+	const throw(c2_exception)
 {
 	int np=xgrid.size();
 	
-	struct c2_integrate_fblock f0, f2;
+	c2_fblock<float_type> f0, f2;
 	struct c2_integrate_recur rb;
 	rb.rel_tol=rel_tol;
@@ -420,6 +523,9 @@
 	rb.adapt=adapt;
 	rb.derivs=derivs;
-	
-	reset_evaluations(); // counter returns with total evaluations needed for this integral
+	std::vector< recur_item > rb_stack;
+	rb_stack.reserve(20); // enough for most operations
+	rb.rb_stack=&rb_stack;
+	rb.inited=false;
+	float_type dx_inv=1.0/std::abs(xgrid.back()-xgrid.front());
 	
 	if(partials) partials->resize(np-1);
@@ -428,6 +534,9 @@
 	
 	f2.x=xgrid[0];
-	f2.y=value_with_derivatives(f2.x, &f2.yp, &f2.ypp);
-	increment_evaluations();
+	fill_fblock(f2);
+	if(c2_isnan(f2.y)) {
+		bad_x_point=f2.x;
+		return f2.y; // can't go any further if a nan has appeared
+	}
 	
 	for(int i=0; i<np-1; i++) {
@@ -435,63 +544,69 @@
 		
 		f2.x=xgrid[i+1];
-		f2.y=value_with_derivatives(f2.x, &f2.yp, &f2.ypp);
-		increment_evaluations();
-		
-		rb.depth=0;
-		rb.abs_tol=abs_tol;
-		rb.f0=&f0; rb.f1=&f2; rb.f2=&f2; // we are really only using the left half for the top level
-		rb.lr=0; // pointer is meaningless; will be filled in in recursion
+		fill_fblock(f2);
+		if(c2_isnan(f2.y)) {
+			bad_x_point=f2.x;
+			return f2.y; // can't go any further if a nan has appeared
+		}
+		
+		rb.abs_tol=abs_tol*std::abs(f2.x-f0.x)*dx_inv; // distribute error tolerance over whole domain
+		rb.f0=&f0; rb.f1=&f2; 
 		float_type ps=integrate_step(rb);
 		sum+=ps;
 		if(partials) (*partials)[i]=ps;
+		if(c2_isnan(ps)) break; // NaN stops integration
 	}
 	return sum;
 }
-
-// declare singleton functions for most common c2_function instances
-#define c2_singleton(X) template <typename float_type> const c2_##X<float_type> c2_##X<float_type>::X=c2_##X();
-c2_singleton(sin)
-c2_singleton(cos)
-c2_singleton(tan)
-c2_singleton(log)
-c2_singleton(exp)
-c2_singleton(sqrt)
-c2_singleton(identity)
-
-// reciprocal is actually parametric (a/x), but make singleton 1/x
-template <typename float_type> const c2_recip<float_type> c2_recip<float_type>::recip=c2_recip(1.0);
-
-#undef c2_singleton
 
 // generate a sampling grid at points separated by dx=5, which is intentionally
 // incommensurate with pi and 2*pi so grid errors are somewhat randomized
-template <typename float_type> std::vector<float_type> &c2_sin<float_type>::get_sampling_grid(float_type xmin, float_type xmax)
-{
-	std::vector<float_type> *result=new std::vector<float_type>;
-	
-	for(; xmin < xmax; xmin+=5.0) result->push_back(xmin);
-	result->push_back(xmax);
-	this->preen_sampling_grid(result);
-	return *result;
-}
-
-template <typename float_type> float_type Identity(float_type x) { return x; } // a useful function
-template <typename float_type> float_type f_one(float_type) { return 1.0; } // the first derivative of identity
-template <typename float_type> float_type f_zero(float_type) { return 0.0; } // the second derivative of identity
+template <typename float_type> void c2_sin_p<float_type>::
+	get_sampling_grid(float_type xmin, float_type xmax,  std::vector<float_type> &grid) const
+{
+	grid.clear();	
+	for(; xmin < xmax; xmin+=5.0) grid.push_back(xmin);
+	grid.push_back(xmax);
+	this->preen_sampling_grid(&grid);
+}
+
+template <typename float_type> float_type c2_function_transformation<float_type>::evaluate(
+		float_type xraw, 
+		float_type y, float_type yp0, float_type ypp0,
+		float_type *yprime, float_type *yprime2) const
+{
+	y=Y.fHasStaticTransforms ? Y.pOut(y) : Y.fOut(y); 
+		
+	if(yprime || yprime2) {
+
+		float_type yp, yp2;
+		if(X.fHasStaticTransforms && Y.fHasStaticTransforms) {
+			float_type fpi=1.0/Y.pInPrime(y);
+			float_type gp=X.pInPrime(xraw);
+			// from Mathematica Dt[InverseFunction[f][y[g[x]]], x]
+			yp=gp*yp0*fpi; // transformed derivative
+			yp2=(gp*gp*ypp0 + X.pInDPrime(xraw)*yp0  - Y.pInDPrime(y)*yp*yp )*fpi; 
+		} else {
+			float_type fpi=1.0/Y.fInPrime(y);
+			float_type gp=X.fInPrime(xraw);
+			// from Mathematica Dt[InverseFunction[f][y[g[x]]], x]
+			yp=gp*yp0*fpi; // transformed derivative
+			yp2=(gp*gp*ypp0 + X.fInDPrime(xraw)*yp0  - Y.fInDPrime(y)*yp*yp )*fpi; 
+		} 
+		if(yprime) *yprime=yp;
+		if(yprime2) *yprime2=yp2;
+	}	
+	return y;
+}
 
 //  The constructor
-template <typename float_type> void interpolating_function<float_type>::init(
+template <typename float_type> interpolating_function_p<float_type> & interpolating_function_p<float_type>::load(
 								const std::vector<float_type> &x, const std::vector<float_type> &f, 
 								bool lowerSlopeNatural, float_type lowerSlope, 
 								bool upperSlopeNatural, float_type upperSlope,
-								float_type (*inputXConversion)(float_type), 
-								float_type (*inputXConversionPrime)(float_type), 
-								float_type (*inputXConversionDPrime)(float_type), 
-								float_type (*inputYConversion)(float_type), 
-								float_type (*inputYConversionPrime)(float_type), 
-								float_type (*inputYConversionDPrime)(float_type), 
-								float_type (*outputYConversion)(float_type)
-					) throw(c2_exception) 
-{
+								bool splined
+		) throw(c2_exception) 
+{
+	c2_ptr<float_type> keepme(*this);
 	X= x;
 	F= f;
@@ -501,13 +616,5 @@
 
 	set_domain(std::min(Xraw.front(), Xraw.back()),std::max(Xraw.front(), Xraw.back()));
-	
-	fXin=inputXConversion;
-	fXinPrime=inputXConversionPrime;
-	fXinDPrime=inputXConversionDPrime;
-	fYin=inputYConversion;
-	fYinPrime=inputYConversionPrime;
-	fYinDPrime=inputYConversionDPrime;
-	fYout=outputYConversion;
-	
+		
 	if(x.size() != f.size()) {
 		throw c2_exception("interpolating_function::init() -- x & y inputs are of different size");
@@ -529,23 +636,13 @@
 	}
 	
-	if(fXin) { // check if X scale is nonlinear, and if so, do transform
-		if(!lowerSlopeNatural) lowerSlope /= fXinPrime(X[0]);
-		if(!upperSlopeNatural) upperSlope /= fXinPrime(X[np-1]);
-		for(size_t i=0; i<np; i++) X[i]=fXin(X[i]);
-	} else {
-		fXin=Identity<float_type>;
-		fXinPrime=f_one<float_type>;
-		fXinDPrime=f_zero<float_type>;
-	}
-	
-	if(inputYConversion) {  // check if Y scale is nonlinear, and if so, do transform
-		if(!lowerSlopeNatural) lowerSlope *= fYinPrime(F[0]);
-		if(!upperSlopeNatural) upperSlope *= fYinPrime(F[np-1]);
-		for(size_t i=0; i<np; i++) F[i]=inputYConversion(F[i]);
-	} else {
-		fYin=Identity<float_type>;
-		fYinPrime=f_one<float_type>;
-		fYinDPrime=f_zero<float_type>;
-		fYout=Identity<float_type>;
+	if(fTransform.X.fTransformed) { // check if X scale is nonlinear, and if so, do transform
+		if(!lowerSlopeNatural) lowerSlope /= fTransform.X.fInPrime(X[0]);
+		if(!upperSlopeNatural) upperSlope /= fTransform.X.fInPrime(X[np-1]);
+		for(size_t i=0; i<np; i++) X[i]=fTransform.X.fIn(X[i]);
+	}	
+	if(fTransform.Y.fTransformed) {  // check if Y scale is nonlinear, and if so, do transform
+		if(!lowerSlopeNatural) lowerSlope *= fTransform.Y.fInPrime(F[0]);
+		if(!upperSlopeNatural) upperSlope *= fTransform.Y.fInPrime(F[np-1]);
+		for(size_t i=0; i<np; i++) F[i]=fTransform.Y.fIn(F[i]);
 	}
 		  
